
(in-package sugar-qsp.api)

(defpsmacro with-call-args (args &body body)
  `(progn
     (init-args ,args)
     ,@body
     (get-result)))

(defpsmacro with-frame (&body body)
  `(progn
     (push-local-frame)
     (unwind-protect
          ,@body
       (pop-local-frame))))

(defpsmacro inline-call (func &rest args)
  `(+ (ps-inline ,func)
      "(\""
      ,(first args)
      ,@(loop :for arg :in (cdr args)
             :collect "\", \""
             :collect arg)
      "\");"))

(defpsmacro with-sleep ((resume-func) &body body)
  `(new (*promise
         (lambda (resolve)
           (start-sleeping)
           (let ((,resume-func (lambda ()
                                 (finish-sleeping)
                                 (resolve)))))
           ,@body))))

